function [SparseSimMat] = GetSimInfo(NetNumNodes, O_pairs)
T=length(NetNumNodes);
N=zeros(T,1);
for i=1:T
    N(i)=NetNumNodes{i};
end
Ntot=sum(N);
o1=[];o2=[];ow=[];
for s1=1:T-1
    for s2=s1+1:T
        w=O_pairs{s1,s2}(:,3);%ones(size(O_pairs{s1,s2},1),1);%get_weight(O_pairs{s1,s2},N(s1),N(s2));
        O_pairs_tmp=O_pairs{s1,s2};
        if s1>1
            o1_tmp=O_pairs_tmp(:,1)+sum(N(1:s1-1));
        else
            o1_tmp=O_pairs_tmp(:,1);
        end
        if s2>1
            o2_tmp=O_pairs_tmp(:,2)+sum(N(1:s2-1));
        else
            o2_tmp=O_pairs_tmp(:,2);
        end
        o1=[o1;o1_tmp];
        o2=[o2;o2_tmp];
        ow=[ow;w];
    end
end
SparseSimMat=sparse(o1,o2,ow,Ntot,Ntot); % duplicated values are added together
SparseSimMat=SparseSimMat+SparseSimMat';

end

function Ow=get_weight(list_orthologs,N1,N2)
O12=sparse(list_orthologs(:,1),list_orthologs(:,2),ones(size(list_orthologs,1),1),N1,N2);
d1=full(sum(O12,2));
d2=full(sum(O12))';
o1=d1(list_orthologs(:,1));
o2=d2(list_orthologs(:,2));
Ow=(1./o1+1./o2)/2;
end