function [partition, conductance] = Greedy_Sim_Dense(CellA_LC, Sim, Lambda, CellIndex_LC, NetNumNodes)

%%%%%%%%%%%%%%%%%%% prepararion %%%%%%%%%%%%%%
% CellA_LC has no self connections
NumNet = length(CellA_LC);
BigA= [];
for i = 1 : NumNet
    TriA{i} = triu(CellA_LC{i});
    BigA = blkdiag(BigA, CellA_LC{i});
end

% %regularied
% for i = 1 : NumNet
%     CellD{i} = CellD{i} + 0*ones(1,length(CellD{i}));
% end

SubNum = [0];
for i = 1 : NumNet
    SubNum = [SubNum length(CellIndex_LC{i})];
end
TSubNum = sum(SubNum);
CSubNum = cumsum(SubNum);

NonZerosA = [];
for i = 1 : NumNet
    NonZerosA = [NonZerosA sum(sum(TriA{i}))];%sum(sum(CellA_LC{i}>0))/2
end

Node2Species = zeros(1,TSubNum);
bastt = 0;
for i = 1 : NumNet
    Node2Species(bastt+1 : bastt+SubNum(i+1)) = i;
    bastt = bastt + SubNum(i+1);
end

S = cell(NumNet,NumNet);
NonZeroS = [];
%Base = 0;
CBase = 0;
for i = 1 : NumNet
    %SBase = SubNum(i);
    CellBase = NetNumNodes{i};
    for j = i+1 : NumNet
        %S(Base+[1:SubNum(i)],SBase+[1:SubNum(j)]) = Sim(CBase+CellIndex_LC{i}, CBase+CellBase+CellIndex_LC{j});
        %SBase = SBase + SubNum(j);
        S{i,j} = Sim(CBase+CellIndex_LC{i}, CBase+CellBase+CellIndex_LC{j});
        NonZeroS = [NonZeroS sum(sum(S{i,j}))];
        CellBase = CellBase + NetNumNodes{j};
    end
    %Base = Base + SubNum(i);
    CBase = CBase + NetNumNodes{i};
end

Index = [];
for i = 1 : NumNet
    Index = [Index; CellIndex_LC{i}];
end

%% if less simimlarity quit
if(sum(NonZeroS)< NumNet && length(NonZeroS) < NumNet-1)
    partition = [];
    conductance = 0;
    return
end



%% construct Sim matrix and sim vector
Sim = sparse(TSubNum,TSubNum);
for i = 1 : NumNet
    for j = i+1 : NumNet
        Sim(CSubNum(i)+1:CSubNum(i+1), CSubNum(j)+1:CSubNum(j+1)) = S{i,j};
    end
end
Sim = Sim+Sim';
SimSum = sum(Sim,2);
IndSim = double(SimSum>=0.1*(NumNet-1));

%% consturct dense vector
% TmpInd = zeros(TSubNum,1);
% for i = 1 : NumNet
%     TmpInd(CSubNum(i)+CellIndex_Dense{i}) = 1;
% end
TmpInd = [];
for i = 1 : NumNet
    tmpNet = CellA_LC{i} - diag(diag(CellA_LC{i}));
    MCt = ELSclique(tmpNet);
    Indt = find(MCt(1,:));
    Indtmp = double(sum(MCt(:,Indt),2)>0);
    TmpInd = [TmpInd; Indtmp];
end


%% overlap between sim and dense vector
IndSimDen = (IndSim+TmpInd);%IndSim;%(IndSim+TmpInd);
IndSimDen = double(IndSimDen>=1);
IndSimDenS = zeros(TSubNum,NumNet);
for i = 1 : NumNet
    IndSimDenS(CSubNum(i)+1:CSubNum(i+1),i) = IndSimDen(CSubNum(i)+1:CSubNum(i+1));
    if(sum(IndSimDen(CSubNum(i)+1:CSubNum(i+1))) < 1)
        return;% in one subnet there is no similiar nodes
    end
end


%% Greedy Method

MaxInc = 10000;
[ObjValT DenseValT SimValT] = Fun_Sim_Dense(BigA, Sim, IndSimDen, IndSimDenS, NumNet, Lambda);
while(MaxInc > 0 && ~isnan(MaxInc))
    IndT = find(IndSimDen>0);
    for ii = 1 : NumNet
        IndTS{ii} = find(IndSimDenS(:,ii)) - CSubNum(ii);
    end
    SubNetNum = sum(IndSimDenS);
    TotalSubNetNum = sum(SubNetNum);
    
    % revome node
    Inc = [];
    for ii = 1 : length(IndT)
        NetID = Node2Species(IndT(ii));
        IndInside = IndT(ii) - CSubNum(NetID);
        % increase on density
        if(SubNetNum(NetID) == 1)
            IncTDense = -DenseValT(NetID);
            DenseNew = 0;
        else
            % without self loop
            IncTDense = (DenseValT(NetID) - (2*sum(CellA_LC{NetID}(IndInside,IndTS{NetID})))*SubNetNum(NetID)) / ((SubNetNum(NetID)-1)*SubNetNum(NetID));
            DenseNew = DenseValT(NetID) - (2*sum(CellA_LC{NetID}(IndInside,IndTS{NetID})));
        end
        % increase on sim just the sum of simialrity not density
        IncTSim = (SimValT - 2*sum(Sim(IndT(ii), IndT))*TotalSubNetNum) / (TotalSubNetNum*(TotalSubNetNum-1));
        SimNew = SimValT - 2*sum(Sim(IndT(ii), IndT));
        IncT = IncTDense + Lambda*IncTSim;
        Inc = [Inc; NetID IndT(ii) DenseNew SimNew IncTDense IncTSim IncT;];
    end
    [MaxInc, Indtt] = max(Inc(:,end));
    
    if(MaxInc <= 0)
        break;
    end
    
    % update
    IdinAll = Inc(Indtt,2);
    IdinNet = Inc(Indtt,1);
    IndSimDen(IdinAll) = 0;
    IndSimDenS(IdinAll,IdinNet) = 0;
    DenseValT(IdinNet) = Inc(Indtt,3);
    SimValT = Inc(Indtt, 4);
    ObjValT = ObjValT + Inc(Indtt, end);
    
end

%% result

for i = 1 : NumNet
    partition{i} = CellIndex_LC{i}(IndSimDen(Node2Species==i)>0);
end
conductance = SimValT;%ObjValT;

end

function [ObjVal DenseVal SimVal] = Fun_Sim_Dense(A, Sim, AssignMat, AssignMatS, NumNet, Lambda)
NumDig = ones(NumNet);
NumDig = NumDig - eye(NumNet) + diag(sum(AssignMatS));
DenseValT = diag((AssignMatS'*A*AssignMatS)./ NumDig);
SimValT = AssignMat'*Sim*AssignMat/sum(AssignMat);
DenseVal = diag((AssignMatS'*A*AssignMatS));
SimVal = AssignMat'*Sim*AssignMat;
ObjVal = sum(DenseValT) + Lambda*SimValT;
end


















