function [partition_co, conductance] = LocalClusterM_Greedy(NetNumNodes, orth_nodes, Network, NetDeg, alpha, eps, LocalNumNodes, Sim, SimThreshold, Lambda)

NumNet = length(NetDeg);
NodeId = cell(1,NumNet);

%% Read in ortholgous nodes
for i = 1 : NumNet
    NodeId{i} = orth_nodes(1,i);
end

%% check degree of each node to decide whether continue
skipid = 0;
for i = 1 : NumNet
    if(NetDeg{i}(NodeId{i}) < 1)
        skipid = 1;
        break;
    end
end
if(skipid == 1)
    partition_co = [];
    conductance = -1;
    return;
end

%% print some info
%disp(['Node Pairs: ' num2str(orth_nodes(1,1)) ' ' num2str(orth_nodes(1,2)) ' ' num2str(orth_nodes(1,3)) ' ' num2str(orth_nodes(1,4))])

%% pagerank vector to get potential local nodes
for i = 1 : NumNet
    [SubNetT{i}, SubDegT{i}, SubIndT{i}] = GetLocalNodes(Network{i}, NetDeg{i}, NodeId{i}, alpha{i}, eps{i}, LocalNumNodes{i});
end

%% check potential node size to decide whether continue
skipid = 0;
for i = 1 : NumNet
    if(length(SubIndT{i}) < 1)
        skipid = 1;
        break;
    end
end
if(skipid == 1)
    partition_co = [];
    conductance = -1;
    return;
end
% 
% if(ComputeSim(SubIndT, Sim, NetNumNodes)<SimThreshold)
%     partition_co = [];
%     conductance = -1;
%     return;
% end

%% low conductance
for i = 1 : NumNet
    [ClustersS ConductanceS] = Low_Conductance(SubNetT{i}, SubDegT{i}, SubIndT{i}, 0);
    SubNet_LC{i} = Network{i}(ClustersS,ClustersS);
    SubDeg_LC{i} = ones(1,length(ClustersS));
    SubInd_LC{i} = ClustersS;
    SubInd_LCT{i} = 1:length(ClustersS);%%%!!!!!!!
end

%% greedy method
[partition_co, conductance] = Greedy_Sim_Dense(SubNet_LC, Sim, Lambda, SubInd_LC, NetNumNodes);

%[partition_co{count}, conductance(count)] = Conductance_Sim_Dense(SubNet, SubDeg, Sim, Lambda, SubInd, NetNumNodes);%Conductance_Sim_Seperate(SubNet, SubDeg, Sim, 1, SubInd, NetNumNodes);


return
