function [Compelxes] = PostProcessing(Network, RawComplexes, NameList)

NetNumNodeCum = [0];
for i = 1 : NumNetALL
    NetNumNodes{i} = length(Network{i});
    NetNumNodeCum = [NetNumNodeCum NetNumNodes{i}];
end

%% remove compelexes with small protien sequence similarity
KID = 1;
for i = 1 : length(RawComplexes)
    
    mlutiNum = [];
    for j = 1 : NumNet
        mlutiNum = [mlutiNum length(RawComplexes{i}{j})];
    end
    minNum = min(mlutiNum);
    
    %orthology
    Orthology = 0;
    OrthologyM = 0;
    Idt1 = [];
    Idt2 = [];
    for k = 1 : NumNet-1
        Idt1 = RawComplexes{i}{k}+NetNumNodeCum(k);
        for l = k+1 : NumNet
            Idt2 = RawComplexes{i}{l}+NetNumNodeCum(l);
            Orthology = Orthology + sum(sum(Sim(Idt1, Idt2)));
            OrthologyM = OrthologyM + sum(sum(Sim(Idt1, Idt2)>0));
        end
    end
    
    if(Orthology > 1 || OrthologyM / minNum > 0.2)
        SComplexes{KID} = RawComplexes{i};
        KID = KID + 1;
    end
    
end


%% remove duplicated complexes
To_del = [];
for i = 1 : length(SComplexes)
    for j = 1 : length(SComplexes)
        if(any(j==To_del) || i == j)
            continue;
        end
        
        Eq = 0;
        for k = 1 : NumNet
            if(isequal(sort(SComplexes{i}{k}),sort(SComplexes{j}{k})))
                Eq = Eq+1;
            end
        end
        
        if(Eq == NumNet)
            To_del = [To_del j];
        end
    end
end
To_del = unique(To_del);

%% write out
fid = fopen('ConservedComplexes.txt', 'w');
ID = 1;
for i = 1 : length(SComplexes)
    
    if(any(i==To_del))
        continue;
    end
    
    Complexes{ID} = SComplexes{i};
    ID = ID + 1;
    
    for j = 1 : NumNet
        for k = 1 : length(SComplexes{i}{j})
            fprintf(fid,'%s ', NameList{j}{SComplexes{i}{j}(k)});
        end
    end
    fprintf(fid, '\n');
    
end
fclose(fid);





